flex --header-file=lex.yy.hpp -o lex.yy.cpp lex.l
bison --defines=yacc.tab.hpp -o yacc.tab.cpp yacc.y

# orderby test
create table t (id int, name char(8));
insert into t values (1, 'march7th');
insert into t values (5, 'firefly');
insert into t values (3, 'kafka');
insert into t values (2, 'ruanmei');

select * from t;
select * from t order by id;
select * from t order by id asc;
select * from t order by id desc;
select * from t order by name;
select * from t order by name asc;
select * from t order by name desc;

insert into t values (4, 'asta');
insert into t values (100, 'ourscore');
insert into t values (1, 'our rank');
select * from t order by id asc;
select * from t order by name desc;

drop table t;

# sort merge join test
create table item (i_id int, i_im_id int, i_name char(24), i_price float, i_data char(50));
create table stock(s_i_id int, s_w_id int, s_quantity int, s_dist_01 char(24), s_dist_02 char(24), s_dist_03 char(24), s_dist_04 char(24), s_dist_05 char(24), s_dist_06 char(24), s_dist_07 char(24), s_dist_08 char(24), s_dist_09 char(24), s_dist_10 char(24), s_ytd float, s_order_cnt int, s_remote_cnt int, s_data char(50));

insert into item values(1, 6539, 'EPjQ', 140.125000, 'HIEtK');
insert into item values(3, 7904, 'Byit', 507.312500, 'qzwfk');
insert into item values(2, 2088, '6BQf', 294.250000, 'FyuyM');

insert into stock values (3, 1, 35, '0oVK', 'pgGX', 'Z7JN', '6D2o', '77xX', 'kf0z', 'cuwy', 'cvac', 'J5v6', 'jbbI', 0.500000, 0, 0, 'JsfN4');
insert into stock values (1, 1, 37, 'ABk7', 'iung', 'sNao', 'LArv', '19yg', 'Fhpp', 'x6ha', 'ulGc', 'wyjd', 'TUHv', 0.500000, 0, 0, 'rqHB0');
insert into stock values (2, 1, 72, '4jH3', 'PViF', 'KgL1', 'Gnlu', 'PfR7', 'GuZY', 'nPO2', 'aMAe', '6Qfv', 'toiD', 0.500000, 0, 0, '42cIn');

select * from item;
select * from stock;

drop index item(i_id);
drop index stock(s_i_id);

# 嵌套循环连接
SET enable_nestloop = true;
SET enable_sortmerge = false;
select * from item, stock where s_i_id = i_id order by i_id;

# 未建立索引时的排序连接
SET enable_nestloop = false;
SET enable_sortmerge = true;
select * from item, stock where s_i_id = i_id order by i_id;

# 建立索引之后的排序连接
create index item(i_id);
create index stock(s_i_id);
select * from item, stock where s_i_id = i_id order by i_id;

# default orderby test
select * from item, stock where i_id = s_i_id;

drop table item;
drop table stock;

# offset test
create table item (i_id int, i_im_id int, i_name char(24), i_price float, i_data char(50));
create table stock(s_i_id int, s_w_id int, s_quantity int, s_dist_01 char(24), s_dist_02 char(24), s_dist_03 char(24), s_dist_04 char(24), s_dist_05 char(24), s_dist_06 char(24), s_dist_07 char(24), s_dist_08 char(24), s_dist_09 char(24), s_dist_10 char(24), s_ytd float, s_order_cnt int, s_remote_cnt int, s_data char(50));

insert into item values(6539, 1, 'EPjQ', 140.125000, 'HIEtK');
insert into item values(7904, 3, 'Byit', 507.312500, 'qzwfk');
insert into item values(2088, 2, '6BQf', 294.250000, 'FyuyM');

insert into stock values (1, 3, 35, '0oVK', 'pgGX', 'Z7JN', '6D2o', '77xX', 'kf0z', 'cuwy', 'cvac', 'J5v6', 'jbbI', 0.500000, 0, 0, 'JsfN4');
insert into stock values (2, 1, 37, 'ABk7', 'iung', 'sNao', 'LArv', '19yg', 'Fhpp', 'x6ha', 'ulGc', 'wyjd', 'TUHv', 0.500000, 0, 0, 'rqHB0');
insert into stock values (3, 2, 72, '4jH3', 'PViF', 'KgL1', 'Gnlu', 'PfR7', 'GuZY', 'nPO2', 'aMAe', '6Qfv', 'toiD', 0.500000, 0, 0, '42cIn');

select * from item, stock where s_w_id = i_im_id;
select * from item, stock where s_i_id = i_im_id;
