/* Copyright (c) 2023 Renmin University of China
RMDB is licensed under Mulan PSL v2.
You can use this software according to the terms and conditions of the Mulan PSL v2.
You may obtain a copy of Mulan PSL v2 at:
        http://license.coscl.org.cn/MulanPSL2
THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
See the Mulan PSL v2 for more details. */

#include "planner.h"

#include <memory>
#include <set>
#include "execution/executor_delete.h"
#include "execution/executor_index_scan.h"
#include "execution/executor_insert.h"
#include "execution/executor_nestedloop_join.h"
#include "execution/executor_projection.h"
#include "execution/executor_seq_scan.h"
#include "execution/executor_update.h"
#include "index/ix.h"
#include "record_printer.h"

// 目前的索引匹配规则为：完全匹配索引字段，且全部为单点查询，不会自动调整where条件的顺序 
//Leftmost matching principle by jinx 20240523 
bool Planner::get_index_cols(std::string tab_name, std::vector<Condition>& curr_conds, std::vector<std::string>& index_col_names,IndexMeta &indexmeta) {
    // return false;
    // std::cout<<"c"<<std::endl;
    index_col_names.clear();
    std::set<std::string> tempnoeq;
    std::set<std::string> temp;
    
     std::cout<<"bingelihai, currcond size "<<curr_conds.size()<<", table name "<<tab_name<<std::endl;
    for(auto& cond: curr_conds) {
        // std::cout<<"wowowowowow "<<cond.lhs_col.col_name<<std::endl;
        if (!cond.is_rhs_val) { // left and right both column, matching join, by march7 20240531
            if (cond.op != OP_EQ) {
                return false; // temporarily support equal join
            }
            // std::cout<<"tab name "<<tab_name<<std::endl;
            // std::cout<<"zuo mingzi "<<cond.lhs_col.tab_name<<" u mingzi "<<cond.rhs_col.tab_name<<std::endl;
            if (cond.rhs_col.tab_name.compare(tab_name) == 0) { // if table right hand side, swap it to left
                std::swap(cond.lhs_col, cond.rhs_col);
            }
            if (cond.lhs_col.tab_name.compare(tab_name) == 0) {
                temp.insert(cond.lhs_col.col_name);
                // std::cout<<"insert colname "<<cond.lhs_col.col_name<<std::endl;
            }
            else {
                return false;
            }
            std::cout << "eqyes, wow!, hehehaha" << std::endl;
        }
        else if (cond.op == OP_EQ && cond.lhs_col.tab_name.compare(tab_name) == 0) {
            // 检查 temp 集合中是否已经存在 cond.lhs_col.col_name
            if (temp.find(cond.lhs_col.col_name) != temp.end()) {
                return false;
            }
            if (tempnoeq.find(cond.lhs_col.col_name) != tempnoeq.end()) {
                return false;
            }            
            std::cout << "eqyes" << std::endl;
            temp.insert(cond.lhs_col.col_name);
        }
        else if (cond.op != OP_EQ && cond.op != OP_NE && cond.lhs_col.tab_name.compare(tab_name) == 0) {
            // 检查 tempnoeq 集合中是否已经存在 cond.lhs_col.col_name
            if (tempnoeq.find(cond.lhs_col.col_name) != tempnoeq.end()) {
                return false;
            }
            if (temp.find(cond.lhs_col.col_name) != temp.end()) {
                return false;
            }           
            std::cout << "eqno" << std::endl;
            tempnoeq.insert(cond.lhs_col.col_name);
        }
        else return false;

    }
    // std::cout<<"bingezhenlihai, curr table name "<<tab_name<<std::endl;
    size_t max_match_len = 0;
    for(auto& index : sm_manager_->db_.get_table(tab_name).indexes) {
        std::string noteq;
        bool found_non_eq = false;
        if (index.col_num <= max_match_len) continue;
        // std::cout<<"table name "<<tab_name<<" really? "<<index.tab_name<<std::endl;
        size_t match_len = 0;
        for(size_t i = 0; i < index.col_num && i < temp.size()+1; ++i) {
            std::cout<<"index name "<<index.cols[i].name<<std::endl;
            //if(index.cols[i].name == temp[i].lhs_col.col_name)
            if((std::find(tempnoeq.begin(),tempnoeq.end(),index.cols[i].name))!=tempnoeq.end())
                {    
                    std::cout<<"findnoeq"<<std::endl;
                    if(found_non_eq&&index.cols[i].name!=noteq){break;}
                    found_non_eq=true;
                    noteq=index.cols[i].name;
                    std::cout<<index.cols[i].name<<std::endl;
                    std::cout<<"cccccc"<<std::endl;
                    match_len++;
                
                }
            else if((std::find(temp.begin(),temp.end(),index.cols[i].name))!=temp.end())
                {

                    std::cout<<"findyeseq"<<std::endl;
                    std::cout<<index.cols[i].name<<std::endl;
                    match_len++;
                    }
            else
                {
                //to do abc suoyin de ac pipei    
                break;}
        }
        if(match_len > max_match_len) {
             //zmjjkk 5/26
            std::vector<Condition> sort_conds;
            std::vector<int> matchidx;
            for(auto&index_col:index.cols) {
                for(int i=0; i<curr_conds.size(); i++) {
                    if(curr_conds[i].lhs_col.col_name==index_col.name) {
                        sort_conds.push_back(curr_conds[i]);
                        matchidx.push_back(i);
                    }
                }
            }
            for(int i=0; i<curr_conds.size(); i++) {
                if(std::find(matchidx.begin(),matchidx.end(),i)==matchidx.end()) {
                    sort_conds.push_back(curr_conds[i]);
                }
            }
            for(auto& cond:sort_conds) {
                std::cout<<"sort:"<<cond.lhs_col.col_name<<std::endl;
            }
            curr_conds = sort_conds;
            //end
            indexmeta=index;
            max_match_len = match_len;
            index_col_names.clear();
            for(size_t i = 0; i < max_match_len; ++i) {
                index_col_names.push_back(index.cols[i].name);
                std::cout<<"index.cols[i].name"<<std::endl;
                std::cout<<index.cols[i].name<<std::endl;
            }
        }
    }
    std::cout<<max_match_len<<std::endl;
    return (max_match_len > 0);
}


/**
 * @brief 表算子条件谓词生成
 *
 * @param conds 条件
 * @param tab_names 表名
 * @return std::vector<Condition>
 */
std::vector<Condition> pop_conds(std::vector<Condition> &conds, std::string tab_names) {
    // auto has_tab = [&](const std::string &tab_name) {
    //     return std::find(tab_names.begin(), tab_names.end(), tab_name) != tab_names.end();
    // };
    std::vector<Condition> solved_conds;
    auto it = conds.begin();
    while (it != conds.end()) {
        if ((tab_names.compare(it->lhs_col.tab_name) == 0 && it->is_rhs_val) || (it->lhs_col.tab_name.compare(it->rhs_col.tab_name) == 0)) {
            solved_conds.emplace_back(std::move(*it));
            it = conds.erase(it);
        } else {
            it++;
        }
    }
    return solved_conds;
}

int push_conds(Condition *cond, std::shared_ptr<Plan> plan)
{
    if(auto x = std::dynamic_pointer_cast<ScanPlan>(plan))
    {
        if(x->tab_name_.compare(cond->lhs_col.tab_name) == 0) {
            return 1;
        } else if(x->tab_name_.compare(cond->rhs_col.tab_name) == 0){
            return 2;
        } else {
            return 0;
        }
    }
    else if(auto x = std::dynamic_pointer_cast<JoinPlan>(plan))
    {
        int left_res = push_conds(cond, x->left_);
        // 条件已经下推到左子节点
        if(left_res == 3){
            return 3;
        }
        int right_res = push_conds(cond, x->right_);
        // 条件已经下推到右子节点
        if(right_res == 3){
            return 3;
        }
        // 左子节点或右子节点有一个没有匹配到条件的列
        if(left_res == 0 || right_res == 0) {
            return left_res + right_res;
        }
        // 左子节点匹配到条件的右边
        if(left_res == 2) {
            // 需要将左右两边的条件变换位置
            std::map<CompOp, CompOp> swap_op = {
                {OP_EQ, OP_EQ}, {OP_NE, OP_NE}, {OP_LT, OP_GT}, {OP_GT, OP_LT}, {OP_LE, OP_GE}, {OP_GE, OP_LE},
            };
            std::swap(cond->lhs_col, cond->rhs_col);
            cond->op = swap_op.at(cond->op);
        }
        x->conds_.emplace_back(std::move(*cond));
        return 3;
    }
    return false;
}

std::shared_ptr<Plan> pop_scan(int *scantbl, std::string table, std::vector<std::string> &joined_tables, 
                std::vector<std::shared_ptr<Plan>> plans)
{
    for (size_t i = 0; i < plans.size(); i++) {
        auto x = std::dynamic_pointer_cast<ScanPlan>(plans[i]);
        if(x->tab_name_.compare(table) == 0)
        {
            scantbl[i] = 1;
            joined_tables.emplace_back(x->tab_name_);
            return plans[i];
        }
    }
    return nullptr;
}


std::shared_ptr<Query> Planner::logical_optimization(std::shared_ptr<Query> query, Context *context)
{
    
    //TODO 实现逻辑优化规则

    return query;
}

std::shared_ptr<Plan> Planner::physical_optimization(std::shared_ptr<Query> query, Context *context)
{
    bool is_sortmerge = false; // optimize sortmerge by march7 20240530
    std::shared_ptr<Plan> plan = make_one_rel(query, is_sortmerge);
    
    // 其他物理优化

    // 处理orderby
    plan = generate_sort_plan(query, std::move(plan), is_sortmerge); 

    return plan;
}



std::shared_ptr<Plan> Planner::make_one_rel(std::shared_ptr<Query> query, bool& is_sortmerge)
{
    auto x = std::dynamic_pointer_cast<ast::SelectStmt>(query->parse);
    std::vector<std::string> tables = query->tables;
    // // Scan table , 生成表算子列表tab_nodes
    std::vector<std::shared_ptr<Plan>> table_scan_executors(tables.size());
    for (size_t i = 0; i < tables.size(); i++) {
        std::vector<Condition> temp_conds = query->conds, curr_conds;
        bool index_join = false; // for join on index by march7 20240531
        if (temp_conds.size() == 1 && !temp_conds[0].is_rhs_val 
            && temp_conds[0].lhs_col.tab_name != temp_conds[0].rhs_col.tab_name) { 
            index_join = true;
            curr_conds = temp_conds;
            printf("join conds\n");
        } else {
            curr_conds = pop_conds(query->conds, tables[i]);
            printf("normal conds\n");
        }
        std::vector<std::string> index_col_names;
        IndexMeta index_meta;
        std::vector<Condition> sort_conds = curr_conds; //zmjjkk 5/25
        bool index_exist = get_index_cols(tables[i], sort_conds, index_col_names, index_meta);
        if (index_join) {
            sort_conds.clear();
            printf("sort empty, %d", sort_conds.size());
        }
        if (index_exist == false) {  // 该表没有索引
            index_col_names.clear();
            table_scan_executors[i] = 
                std::make_shared<ScanPlan>(T_SeqScan, sm_manager_, tables[i], pop_conds(query->conds, tables[i]), index_col_names, index_meta);
        } else {  // 存在索引
            table_scan_executors[i] =
                std::make_shared<ScanPlan>(T_IndexScan, sm_manager_, tables[i], sort_conds, index_col_names, index_meta);
        }

    }
    // 只有一个表，不需要join。
    if(tables.size() == 1)
    {
        return table_scan_executors[0];
    }
    // 获取where条件
    auto conds = std::move(query->conds);
    std::shared_ptr<Plan> table_join_executors;
    
    int scantbl[tables.size()];
    for(size_t i = 0; i < tables.size(); i++)
    {
        scantbl[i] = -1;
    }
    // 假设在ast中已经添加了jointree，这里需要修改的逻辑是，先处理jointree，然后再考虑剩下的部分
    if(conds.size() >= 1)
    {
        // 有连接条件

        // 根据连接条件，生成第一层join
        std::vector<std::string> joined_tables(tables.size());
        auto it = conds.begin();
        while (it != conds.end()) {
            std::shared_ptr<Plan> left , right;
            left = pop_scan(scantbl, it->lhs_col.tab_name, joined_tables, table_scan_executors);
            right = pop_scan(scantbl, it->rhs_col.tab_name, joined_tables, table_scan_executors);
            std::vector<Condition> join_conds{*it};
            //建立join
            // 判断使用哪种join方式
            if(enable_nestedloop_join && enable_sortmerge_join) {
                // 默认nested loop join
                table_join_executors = std::make_shared<JoinPlan>(T_NestLoop, std::move(left), std::move(right), join_conds);
            } else if(enable_nestedloop_join) {
                table_join_executors = std::make_shared<JoinPlan>(T_NestLoop, std::move(left), std::move(right), join_conds);
            } else if(enable_sortmerge_join) {
                is_sortmerge = true;
                table_join_executors = std::make_shared<JoinPlan>(T_SortMerge, std::move(left), std::move(right), join_conds);
            } else {
                // error
                throw RMDBError("No join executor selected!");
            }

            // table_join_executors = std::make_shared<JoinPlan>(T_NestLoop, std::move(left), std::move(right), join_conds);
            it = conds.erase(it);
            break;
        }
        // 根据连接条件，生成第2-n层join
        it = conds.begin();
        while (it != conds.end()) {
            std::shared_ptr<Plan> left_need_to_join_executors = nullptr;
            std::shared_ptr<Plan> right_need_to_join_executors = nullptr;
            bool isneedreverse = false;
            if (std::find(joined_tables.begin(), joined_tables.end(), it->lhs_col.tab_name) == joined_tables.end()) {
                left_need_to_join_executors = pop_scan(scantbl, it->lhs_col.tab_name, joined_tables, table_scan_executors);
            }
            if (std::find(joined_tables.begin(), joined_tables.end(), it->rhs_col.tab_name) == joined_tables.end()) {
                right_need_to_join_executors = pop_scan(scantbl, it->rhs_col.tab_name, joined_tables, table_scan_executors);
                isneedreverse = true;
            } 

            if(left_need_to_join_executors != nullptr && right_need_to_join_executors != nullptr) {
                std::vector<Condition> join_conds{*it};
                std::shared_ptr<Plan> temp_join_executors = std::make_shared<JoinPlan>(T_NestLoop, 
                                                                    std::move(left_need_to_join_executors), 
                                                                    std::move(right_need_to_join_executors), 
                                                                    join_conds);
                table_join_executors = std::make_shared<JoinPlan>(T_NestLoop, std::move(temp_join_executors), 
                                                                    std::move(table_join_executors), 
                                                                    std::vector<Condition>());
            } else if(left_need_to_join_executors != nullptr || right_need_to_join_executors != nullptr) {
                if(isneedreverse) {
                    std::map<CompOp, CompOp> swap_op = {
                        {OP_EQ, OP_EQ}, {OP_NE, OP_NE}, {OP_LT, OP_GT}, {OP_GT, OP_LT}, {OP_LE, OP_GE}, {OP_GE, OP_LE},
                    };
                    std::swap(it->lhs_col, it->rhs_col);
                    it->op = swap_op.at(it->op);
                    left_need_to_join_executors = std::move(right_need_to_join_executors);
                }
                std::vector<Condition> join_conds{*it};
                table_join_executors = std::make_shared<JoinPlan>(T_NestLoop, std::move(left_need_to_join_executors), 
                                                                    std::move(table_join_executors), join_conds);
            } else {
                push_conds(std::move(&(*it)), table_join_executors);
            }
            it = conds.erase(it);
        }
    } else {
        table_join_executors = table_scan_executors[0];
        scantbl[0] = 1;
    }

    //连接剩余表
    for (size_t i = 0; i < tables.size(); i++) {
        if(scantbl[i] == -1) {
            table_join_executors = std::make_shared<JoinPlan>(T_NestLoop, std::move(table_scan_executors[i]), 
                                                    std::move(table_join_executors), std::vector<Condition>());
        }
    }

    return table_join_executors;

}


std::shared_ptr<Plan> Planner::generate_sort_plan(std::shared_ptr<Query> query, std::shared_ptr<Plan> plan, bool& is_sortmerge)
{
    auto x = std::dynamic_pointer_cast<ast::SelectStmt>(query->parse);
    if(!x->has_sort) {
        return plan;
    }
    std::vector<std::string> tables = query->tables;
    std::vector<ColMeta> all_cols;
    for (auto &sel_tab_name : tables) {
        // 这里db_不能写成get_db(), 注意要传指针
        const auto &sel_tab_cols = sm_manager_->db_.get_table(sel_tab_name).cols;
        all_cols.insert(all_cols.end(), sel_tab_cols.begin(), sel_tab_cols.end());
    }
    TabCol sel_col;
    for (auto &col : all_cols) {
        if(col.name.compare(x->order->cols->col_name) == 0 )
        sel_col = {.tab_name = col.tab_name, .col_name = col.name};
    }
    return std::make_shared<SortPlan>(T_Sort, std::move(plan), sel_col, 
                                    x->order->orderby_dir == ast::OrderBy_DESC, is_sortmerge);
}


/**
 * @brief select plan 生成
 *
 * @param sel_cols select plan 选取的列
 * @param tab_names select plan 目标的表
 * @param conds select plan 选取条件
 */
std::shared_ptr<Plan> Planner::generate_select_plan(std::shared_ptr<Query> query, Context *context) {
    //逻辑优化
    query = logical_optimization(std::move(query), context);

    //物理优化
    auto sel_cols = query->cols;
    std::shared_ptr<Plan> plannerRoot = physical_optimization(query, context);
    plannerRoot = std::make_shared<ProjectionPlan>(T_Projection, std::move(plannerRoot), 
                                                        std::move(sel_cols));

    return plannerRoot;
}

// 生成DDL语句和DML语句的查询执行计划
std::shared_ptr<Plan> Planner::do_planner(std::shared_ptr<Query> query, Context *context)
{
    std::shared_ptr<Plan> plannerRoot;
    if (auto x = std::dynamic_pointer_cast<ast::CreateTable>(query->parse)) {
        // create table;
        std::vector<ColDef> col_defs;
        for (auto &field : x->fields) {
            if (auto sv_col_def = std::dynamic_pointer_cast<ast::ColDef>(field)) {
                ColDef col_def = {.name = sv_col_def->col_name,
                                  .type = interp_sv_type(sv_col_def->type_len->type),
                                  .len = sv_col_def->type_len->len};
                col_defs.push_back(col_def);
            } else {
                throw InternalError("Unexpected field type");
            }
        }
        plannerRoot = std::make_shared<DDLPlan>(T_CreateTable, x->tab_name, std::vector<std::string>(), col_defs);
    } else if (auto x = std::dynamic_pointer_cast<ast::DropTable>(query->parse)) {
        // drop table;
        plannerRoot = std::make_shared<DDLPlan>(T_DropTable, x->tab_name, std::vector<std::string>(), std::vector<ColDef>());
    } else if (auto x = std::dynamic_pointer_cast<ast::CreateIndex>(query->parse)) {
        // create index;
        plannerRoot = std::make_shared<DDLPlan>(T_CreateIndex, x->tab_name, x->col_names, std::vector<ColDef>());
    } else if (auto x = std::dynamic_pointer_cast<ast::DropIndex>(query->parse)) {
        // drop index
        plannerRoot = std::make_shared<DDLPlan>(T_DropIndex, x->tab_name, x->col_names, std::vector<ColDef>());
    } else if (auto x = std::dynamic_pointer_cast<ast::InsertStmt>(query->parse)) {
        // insert;
        plannerRoot = std::make_shared<DMLPlan>(T_Insert, std::shared_ptr<Plan>(),  x->tab_name,  
                                                    query->values, std::vector<Condition>(), std::vector<SetClause>());
    } else if (auto x = std::dynamic_pointer_cast<ast::DeleteStmt>(query->parse)) {
        // delete;
        // 生成表扫描方式
        std::shared_ptr<Plan> table_scan_executors;
        // 只有一张表，不需要进行物理优化了
        // int index_no = get_indexNo(x->tab_name, query->conds);
        std::vector<std::string> index_col_names;
        IndexMeta index_meta;
        std::vector<Condition> sort_conds = query->conds; //zmjjkk 5/25
        bool index_exist = get_index_cols(x->tab_name, query->conds, index_col_names,index_meta);
        
        if (index_exist == false) {  // 该表没有索引
            index_col_names.clear();
            table_scan_executors = 
                std::make_shared<ScanPlan>(T_SeqScan, sm_manager_, x->tab_name, query->conds, index_col_names,index_meta);
        } else {  // 存在索引
            table_scan_executors =
                std::make_shared<ScanPlan>(T_IndexScan, sm_manager_, x->tab_name, sort_conds, index_col_names,index_meta);
        }

        plannerRoot = std::make_shared<DMLPlan>(T_Delete, table_scan_executors, x->tab_name,  
                                                std::vector<Value>(), query->conds, std::vector<SetClause>());
    } else if (auto x = std::dynamic_pointer_cast<ast::UpdateStmt>(query->parse)) {
        // update;
        // 生成表扫描方式
        std::shared_ptr<Plan> table_scan_executors;
        // 只有一张表，不需要进行物理优化了
        // int index_no = get_indexNo(x->tab_name, query->conds);
        std::vector<std::string> index_col_names;
        IndexMeta index_meta;
        std::vector<Condition> sort_conds = query->conds; // zmjkk 5/25
        bool index_exist = get_index_cols(x->tab_name, sort_conds, index_col_names,index_meta);

        if (index_exist == false) {  // 该表没有索引
        index_col_names.clear();
            table_scan_executors = 
                std::make_shared<ScanPlan>(T_SeqScan, sm_manager_, x->tab_name, query->conds, index_col_names,index_meta);
        } else {  // 存在索引
            table_scan_executors =
                std::make_shared<ScanPlan>(T_IndexScan, sm_manager_, x->tab_name, sort_conds, index_col_names,index_meta);
        }
        plannerRoot = std::make_shared<DMLPlan>(T_Update, table_scan_executors, x->tab_name,
                                                     std::vector<Value>(), query->conds, 
                                                     query->set_clauses);
    } else if (auto x = std::dynamic_pointer_cast<ast::SelectStmt>(query->parse)) {

        std::shared_ptr<plannerInfo> root = std::make_shared<plannerInfo>(x);
        // 生成select语句的查询执行计划
        std::shared_ptr<Plan> projection = generate_select_plan(std::move(query), context);
        plannerRoot = std::make_shared<DMLPlan>(T_select, projection, std::string(), std::vector<Value>(),
                                                    std::vector<Condition>(), std::vector<SetClause>());
    } else {
        throw InternalError("Unexpected AST root");
    }
    return plannerRoot;
}